/*
 * Copyright 2018 gil.costa.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package lib;

import java.awt.Component;
import java.io.PrintWriter;
import java.io.StringWriter;
import javax.swing.JOptionPane;

/**
 *
 * @author gil.costa
 */
public final class ExceptionUtils {
    
    public static String toString(Exception ex){
        StringWriter writer = new StringWriter();
        PrintWriter printWriter = new PrintWriter(writer);
        printWriter.println(ex.getMessage());
        ex.printStackTrace(printWriter);
        printWriter.flush();
        return writer.toString();
    }
    
    public static void showError(Component parent, String text){
        String title = "Wops!";
        JOptionPane.showMessageDialog(parent,
            text, title,
            JOptionPane.ERROR_MESSAGE
        );
    }
    
    public static void showError(Component parent, String text, Exception ex){
        showError(parent, text + "\n\n" + toString(ex));
    }
    
}
